# -*-Makefile-*-

# Tools are invoked with --verbose $(VERBOSE)
# Use make check VERBOSE=5 (for example) to raise the verbosity level.
VERBOSE=0
KEEP=0
PARSE_CXX_OPT=
PARSE_DXX_OPT=

parse-cxx:
	XTC_REPOSITORY=$(BUILD_REPOSITORY)			\
        $(top_builddir)/cxx-grammar/src/parser/parse-cxx	\
	--verbose $(VERBOSE) --keep $(KEEP) $(PARSE_CXX_OPT)	\
        -i $(SRC) -o cxx-out

parse-dxx:
	XTC_REPOSITORY=$(BUILD_REPOSITORY)			\
        $(top_builddir)/cxx-grammar/src/parser/parse-cxx	\
	--verbose $(VERBOSE) --keep $(KEEP) $(PARSE_DXX_OPT)	\
        -dxx strict -i $(SRC) -o dxx-out

$(TESTS): test
	@PWD="`pwd`"; \
	if [ x"`basename $$PWD`" = x"gcc" ]; then \
	  mkdir -p abi compat eh expr ext inherit init lookup opt other \
	           overload parse special template warn; \
	  for i in $(TESTS); do $(LN_S) -f ../$(srcdir)/test $$i; done; \
	else \
	  for i in $(TESTS); do \
	    echo "$$i" | grep -qe '-ag$$' && \
	      $(LN_S) -f $(srcdir)/test-ag $$i || $(LN_S) -f $(srcdir)/test $$i; \
	  done; \
	fi

check-one:
	$(TESTS_ENVIRONMENT) ./$(SRC)

TESTS_ENVIRONMENT = XTC_REPOSITORY=$(BUILD_REPOSITORY) SRCDIR=$(srcdir) \
			MAKE=$(MAKE) XFAIL_TESTS="$(XFAIL_TESTS)"

CLEANFILES = $(TESTS) cxx-out cxx-err dxx-out dxx-err
